Goldlantern = LibStub("AceAddon-3.0"):NewAddon("TimerTest", "AceTimer-3.0", "AceEvent-3.0", "AceConsole-3.0")

local options = {
    name = "Goldlantern",
    handler = Goldlantern,
    type = "group",
    args = {
        OnOff = {
            type = "toggle",
            name = "Turn On/Off",
            desc = "Toggles Goldlantern On/Off.",
            set = "ToggleOnOff",
        },
    },
}

function Goldlantern:OnInitialize()
    -- Called when the addon is loaded

    LibStub("AceConfig-3.0"):RegisterOptionsTable("Goldlantern", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Goldlantern", "Goldlantern")
end

function Goldlantern:ToggleOnOff(info, value)
    self.Print("Why would you ever turn this amazing addon off? Silly person.")
end

function Goldlantern:OnEnable()
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
end

function Goldlantern:ZONE_CHANGED_NEW_AREA()
	self:CancelAllTimers() -- cancel any existing timers so no spam
   self:ScheduleTimer("GLtimer", 5) -- wait to send message
end

function Goldlantern:GLtimer()
	local s = "GOLDLANTERN!!!"
	local index = GetChannelName(1) -- It finds General is a channel at index 1
	if (index~=nil) then 
		SendChatMessage(s , "CHANNEL", nil, index); 
	end
end

-- "Every little thing I does is magic! Everything I do just turns you on! Even though your life before was tragic, now Goldlantern's love for you goes on!" - Goldlantern